
INCLUDE Irvine32.inc
INCLUDE macros.inc

BUFFER_SIZE = 50

.data
buffer BYTE BUFFER_SIZE DUP(?)
filename    BYTE 80 DUP(0)
fileHandle  HANDLE ?
filename2     BYTE "output.txt",0
fileHandle2   HANDLE ?
stringLength DWORD ?
bytesWritten DWORD ?
str1 BYTE "Cannot create file",0dh,0ah,0
str2 BYTE "Bytes written to file [output.txt]: ",0
str3 BYTE "Enter up to 500 characters and press "
     BYTE "[Enter]: ",0dh,0ah,0

.code
main PROC

; Let user input a filename.
	mWrite "Enter an input filename: "
	mov	edx,OFFSET filename
	mov	ecx,SIZEOF filename
	call	ReadString

; Open the file for input.
	mov	edx,OFFSET filename
	call	OpenInputFile
	mov	fileHandle,eax

; Check for errors.
	cmp	eax,INVALID_HANDLE_VALUE		; error opening file?
	jne	file_ok					; no: skip
	mWrite <"Cannot open file",0dh,0ah>
	jmp	quit						; and quit
file_ok:

; Read the file into a buffer.
	mov	edx,OFFSET buffer
	mov	ecx,BUFFER_SIZE
	call	ReadFromFile
	jnc	check_buffer_size			; error reading?
	mWrite "Error reading file. "		; yes: show error message
	call	WriteWindowsMsg
	jmp	close_file
	
check_buffer_size:
	cmp	eax,BUFFER_SIZE			; buffer large enough?
	jb	buf_size_ok				; yes
	mWrite <"Error: Buffer too small for the file",0dh,0ah>
	jmp	quit						; and quit
	
buf_size_ok:	
	mov	buffer[eax],0		; insert null terminator
	mWrite "File size: "
	call	WriteDec			; display file size
	call	Crlf

; Display the buffer.
	mWrite <"Buffer:",0dh,0ah,0dh,0ah>
	mov	edx,OFFSET buffer	; display the buffer
	mov ebx,edx
	call	WriteString
	call	Crlf

close_file:
	mov	eax,fileHandle
	call	CloseFile
	jmp create_new_file

; Create a new text file.
create_new_file:
	mov	edx,OFFSET filename2
	call	CreateOutputFile
	mov	fileHandle2,eax

; Check for errors.
	cmp	eax, INVALID_HANDLE_VALUE	; error found?
	jne	file_ok2					; no: skip
	mov	edx,OFFSET str1			; display error
	call	WriteString
	jmp	quit
file_ok2:

; Ask the user to input a string.
;	mov	edx,OFFSET str3		; "Enter up to ...."
;	call	WriteString
;	mov	ecx,BUFFER_SIZE		; Input a string
;	mov	edx,OFFSET buffer
;	call	ReadString
;	mov	stringLength,eax		; counts chars entered

; Write the buffer to the output file.
	mov	eax,fileHandle2
;	mov	edx,OFFSET buffer
	mov edx,ebx                 ; I thought I stored my input text into ebx, but I guess not.
	mov	ecx,stringLength
	call	WriteToFile
	mov	bytesWritten,eax		; save return value
	call	CloseFile
	
; Display the return value.
	mov	edx,OFFSET str2		; "Bytes written"
	call	WriteString
	mov	eax,bytesWritten
	call	WriteDec
	call	Crlf


quit:
	exit
main ENDP

END main